#!/usr/bin/env python
import wx

def init_dplug(dplug):
    dplug.plugins.sheetupdate = SheetUpdate(dplug)
    dplug.add_to("new","sheetupdate")
    dplug.add_to("open","sheetupdate")

def trigger(trig, dplug):
    dplug.plugins.sheetupdate.Update()

class SheetUpdate():
    def __init__(self, dplug):
        self.dplug = dplug
        self.gui = dplug.main_class
        self.dplug.create("sheetupdate")
        self.Update()

    def Update(self):
        for tab in self.gui.tabs:
            if tab.isFile:
                tab.editor.Bind(wx.EVT_KEY_DOWN, self.__fc_factory(tab), tab.editor)
                tab.editor.Bind(wx.EVT_KEY_UP, self.__ku_factory(tab), tab.editor)

    def __fc_factory(self, i):
        """Switcher help function"""
        def _switcher(event):
            """helper function"""
            return self.keychanged(event, i)
        return _switcher
    
    def __ku_factory(self, i):
        """Switcher help function"""
        def _switcher(event):
            """helper function"""
            return self.keyup(event, i)
        return _switcher

    def keyup(self, evt, tab):
        """ this updates the sheetupdate trigger and if nothing returned it will do an evt.Skip() """
        if self.dplug.trigger_update("sheetupdateup", (evt, tab)) != False:
            evt.Skip()

    def keychanged(self, evt, tab):
        """ this updates the sheetupdate trigger and if nothing returned it will do an evt.Skip() """
        if self.dplug.trigger_update("sheetupdate", (evt, tab)) != False:
            evt.Skip()
